<template>
  <component
    is="a-modal"
    :width="tool.getDevice() === 'mobile' ? '100%' : '600px'"
    v-model:visible="visible"
    :title="title"
    :mask-closable="false"
    :ok-loading="loading"
    @cancel="close"
    @before-ok="submit">
    <!-- 表单信息 start -->
    <a-form ref="formRef" :model="formData" :rules="rules" :auto-label-width="true">
      <a-form-item label="媒体渠道ID" field="media_id">
        <a-input v-model="formData.media_id" placeholder="请输入媒体渠道ID" />
      </a-form-item>
      <a-form-item label="应用名称" field="name">
        <a-input v-model="formData.name" placeholder="请输入应用名称" />
      </a-form-item>
      <a-form-item label="应用ID" field="app_id">
        <a-input v-model="formData.app_id" placeholder="请输入应用ID" />
      </a-form-item>
      <a-form-item label="应用密钥" field="app_secret">
        <a-input v-model="formData.app_secret" placeholder="请输入应用密钥" />
      </a-form-item>
      <a-form-item label="OAuth授权地址" field="auth_url">
        <a-input v-model="formData.auth_url" placeholder="请输入OAuth授权地址" />
      </a-form-item>
      <a-form-item label="Token获取地址" field="token_url">
        <a-input v-model="formData.token_url" placeholder="请输入Token获取地址" />
      </a-form-item>
      <a-form-item label="Token刷新地址" field="refresh_url">
        <a-input v-model="formData.refresh_url" placeholder="请输入Token刷新地址" />
      </a-form-item>
    </a-form>
    <!-- 表单信息 end -->
  </component>
</template>

<script setup>
import { ref, reactive, computed } from 'vue'
import tool from '@/utils/tool'
import { Message, Modal } from '@arco-design/web-vue'
import api from '../../api/advert/app'

const emit = defineEmits(['success'])
// 引用定义
const visible = ref(false)
const loading = ref(false)
const formRef = ref()
const mode = ref('')

let title = computed(() => {
  return '开放平台应用授权信息' + (mode.value == 'add' ? '-新增' : '-编辑')
})

// 表单初始值
const initialFormData = {
  id: null,
  media_id: null,
  name: '',
  app_id: '',
  app_secret: '',
  auth_url: '',
  token_url: '',
  refresh_url: '',
}

// 表单信息
const formData = reactive({ ...initialFormData })

// 验证规则
const rules = {
  media_id: [{ required: true, message: '媒体渠道ID必需填写' }],
  name: [{ required: true, message: '应用名称必需填写' }],
  app_id: [{ required: true, message: '应用ID必需填写' }],
  app_secret: [{ required: true, message: '应用密钥必需填写' }],
  auth_url: [{ required: true, message: 'OAuth授权地址必需填写' }],
  token_url: [{ required: true, message: 'Token获取地址必需填写' }],
  refresh_url: [{ required: true, message: 'Token刷新地址必需填写' }],
}

// 打开弹框
const open = async (type = 'add') => {
  mode.value = type
  // 重置表单数据
  Object.assign(formData, initialFormData)
  formRef.value.clearValidate()
  visible.value = true
  await initPage()
}

// 初始化页面数据
const initPage = async () => {}

// 设置数据
const setFormData = async (data) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      formData[key] = data[key]
    }
  }
}

// 数据保存
const submit = async (done) => {
  const validate = await formRef.value?.validate()
  if (!validate) {
    loading.value = true
    let data = { ...formData }
    let result = {}
    if (mode.value === 'add') {
      // 添加数据
      data.id = undefined
      result = await api.save(data)
    } else {
      // 修改数据
      result = await api.update(data.id, data)
    }
    if (result.code === 200) {
      Message.success('操作成功')
      emit('success')
      done(true)
    }
    // 防止连续点击提交
    setTimeout(() => {
      loading.value = false
    }, 500)
  }
  done(false)
}

// 关闭弹窗
const close = () => (visible.value = false)

defineExpose({ open, setFormData })
</script>
